SystemOrganization addCategory: #'Orange-AngularJS'!

ALComponentResource subclass: #ORAJSAuthResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-AngularJS'!

!ORAJSAuthResource commentStamp: 'chc 6/22/2015 14:51' prior: 0!
Catches a username and password sent as JSON by a compoment like ORAngularJS. !

!ORAJSAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 7/6/2015 11:55'!
authorized: result locator: aLocator
	| root cookie url |
	root := component rematerialize.
	"[root noteDispatch]
		on: ALUserStipulation
		do: [:stipulation | stipulation component auth: true ]."
	url := aLocator urlForResource: root asResource.
	cookie := ALCookie name: 'auth' value: result token.
	cookie path: '/'.
	^ (ALResponse seeOther: url)
		setCookie: cookie;
		"date: DateAndTime now;
		keepAlive: 'timeout=10, max=20';"
		yourself! !

!ORAJSAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 3/11/2015 14:17'!
denied
	^ ALResponse status: 401 reason: 'Authentication failed'! !

!ORAJSAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 7/6/2015 11:56'!
handleGet: aRequest locator: aLocator
	| request result authstring |
self halt.
	(aRequest authorization isNil)
		ifTrue: [^self respondWithChallenge]
		ifFalse: [
	authstring := (aRequest authorization copyAfter: Character space) base64Decoded.
	request := ALAuthenticationRequest withUsername:  (authstring copyUpTo: $:)   password: (authstring copyAfter: $:).
	result := request signal].
	^(result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [ self denied ]
			! !

!ORAJSAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 7/9/2015 13:26'!
handlePost: aRequest locator: aLocator
	| request result |
	request := ALAuthenticationRequest new.
	aRequest readEntityWith: 
		[:in | ALJsonParser  parse: in for: request].
	result := request signal.
	^ (result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [self denied]! !

ALAsyncExample subclass: #ORAJSAuthComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-AngularJS'!

!ORAJSAuthComponent commentStamp: 'chc 6/22/2015 14:43' prior: 0!
Used by ORExamplePage where it is added to initialize to add an AngularJS Javascript example.

!

!ORAJSAuthComponent methodsFor: 'as yet unclassified' stamp: 'chc 7/10/2015 14:18'!
libraryScript
	^'angular.module(''notesApp'', [])
		.controller(''MainCtrl'', [''$http'',function($http) {
			var self = this;
			self.change = function () {
				self.username = ''changed'';
				self.password = ''password'';
				};
			self.submit = function () {
				$http.post( ''/json'',
				{ "username" :  self.username, 
				   "password" : self.password}
							).success(function(data) {
								self.sharkweek = data;}
							);
					};	
		}]);'! !

!ORAJSAuthComponent methodsFor: 'as yet unclassified' stamp: 'chc 7/10/2015 14:47'!
renderContentOn: html
	html input beTypeText; ngModel: 'ctrl.username'.
	html input beTypePassword; ngModel: 'ctrl.password'.
	html button ngClick: 'ctrl.change()'; with: 'Change Values'.
	html button ngClick: 'ctrl.submit()'; with: 'Submit'.
	html br.
	html span ngBind: 'ctrl.sharkweek'.
	self renderScriptsOn: html! !

!ORAJSAuthComponent methodsFor: 'as yet unclassified' stamp: 'chc 12/31/2014 13:41'!
renderScriptsOn: html
	html script src: 'https://ajax.googleapis.com/ajax/libs/angularjs/1.2.19/angular.js'.
	html script
		type: 'application/javascript';
		with: [html raw: self libraryScript].
	"html script
		type: 'application/javascript';
		with: [self renderInitScriptOn: html]"! !

ALAsyncExample subclass: #ORAJSHelloWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-AngularJS'!

!ORAJSHelloWorld commentStamp: '<historical>' prior: 0!
Used by ORExamplePage where it is added to initialize to add an AngularJS Javascript example.

!

!ORAJSHelloWorld methodsFor: 'as yet unclassified' stamp: 'chc 7/11/2015 11:44'!
renderContentOn: html
	html input beTypeText; ngModel: 'name'; with: 'Enter your name'.
	html br.
	html span ngBind: 'name'.
	self renderScriptsOn: html! !

!ORAJSHelloWorld methodsFor: 'as yet unclassified' stamp: 'chc 7/11/2015 11:41'!
renderScriptsOn: html
	html script src: 'https://ajax.googleapis.com/ajax/libs/angularjs/1.2.19/angular.js'.
	! !
